Gyoto::Astrobj::StarTrace Class Referenceabstract

Like a Star that would be on all points of its orbit at all time. More...

`#include <GyotoStarTrace.h>`

Inheritance diagram for Gyoto::Astrobj::StarTrace:

## Public Types

typedef Gyoto::SmartPointer< Gyoto::SmartPointee > | Subcontractor_t(Gyoto::FactoryMessenger *, std::vector< std::string > const &)
| A subcontractor builds an object upon order from the Factory.

## Public Member Functions

virtual Property const * | getProperties () const
| Get list of properties.
| StarTrace (SmartPointer< Metric::Generic > gg, double radius, double const pos[4], double const v[3])
| Create Star object and set initial condition.
| StarTrace ()
| Default constructor.
| StarTrace (const StarTrace &orig)
| Copy constructor.
| StarTrace (const Star &o, double tmin, double tmax)
| Build StarTrace from Star.
virtual StarTrace * | clone () const
| Cloner.
virtual | ~StarTrace ()
| Destructor.
void | xAllocate (size_t)
| Allocate x0, x1 etc. with a specified size.
void | xAllocateXYZ ()
| Allocate x_, y_, z_.
size_t | xExpand (int)
| Expand x0, x1 etc... to hold more elements.
void | computeXYZ (size_t i)
| Compute (and cache) x_, y_ and z_ for one date.
void | computeXYZ ()
| Compute (and cache) x_, y_ and z_.
virtual void | setInitCoord (const double coord[8], int dir=0)
| Set Initial coordinate.
virtual void | metric (SmartPointer< Metric::Generic > gg)
| Set the Metric gg_.
virtual void | xStore (size_t ind, state_t const &coord, double tau)
| Store coord at index ind.
virtual std::string | className () const
| "StarTrace"
virtual std::string | className_l () const
| "startrace"
double | TMin () const
| Get tmin_.
void | TMin (double)
| Set tmin_.
double | TMax () const
| Get tmax_.
void | TMax (double)
| Set tmax_.
virtual void | setInitialCondition (double const coord[8])
| Same as Worldline::setInitialCondition(gg, coord, sys,1).
virtual double | operator() (double const coord[4])
| Square distance to the center of the sphere.
virtual SmartPointer< Metric::Generic > | metric () const
| Get the Metric gg_.
virtual double | getMass () const
| Return 1.
virtual double | rMax ()
| Get maximal distance from center of coordinate system.
virtual double | rMax () const
| Get maximal distance from center of coordinate system.
virtual double | rMax (std::string const &unit)
| Get rmax_ is specified unit.
virtual double | rMax (std::string const &unit) const
| Get rmax_ is specified unit.
virtual void | rMax (double val)
| Set maximal distance from center of coordinate system.
virtual void | rMax (double val, std::string const &unit)
| Set maximal distance from center of coordinate system.
void | setInitialCondition (SmartPointer< Metric::Generic > gg, const double coord[8], const int dir, double const Ephi[4], double const Etheta[4])
| Set or re-set the initial condition prior to integration.
void | setInitialCondition (SmartPointer< Metric::Generic > gg, const double coord[8], const int dir)
| Set or re-set the initial condition prior to integration.
virtual int | setParameter (std::string name, std::string content, std::string unit)
| Set parameter by name.
virtual void | setParameter (Gyoto::Property const &p, std::string const &name, std::string const &content, std::string const &unit)
| Set parameter by Property (and name).
virtual void | setParameters (FactoryMessenger *fmp)
| Main loop in Subcontractor_t function.
virtual void | fillProperty (Gyoto::FactoryMessenger *fmp, Property const &p) const
| Output a single Property to XML.
virtual void | getCartesian (double const *const dates, size_t const n_dates, double *const x, double *const y, double *const z, double *const xprime=NULL, double *const yprime=NULL, double *const zprime=NULL)
| Get the 6 Cartesian coordinates for specific dates.
virtual void | getVelocity (double const pos[4], double vel[4])
| Yield velocity of the center of the sphere.
virtual void | radiativeQ (double *Inu, double *Qnu, double *Unu, double *Vnu, Eigen::Matrix4d *Onu, double const *nuem, size_t nbnu, double dsem, state_t const &cph, double const *co) const
| Compute the increment of Stokes parameters and transmission matrix. Polarised version of RadiaveQ.
virtual void | radiativeQ (double Inu[], double Taunu[], double const nu_em[], size_t nbnu, double dsem, state_t const &coord_ph, double const coord_obj[8]=NULL) const
| emission and transmission together
virtual void | radiativeQ (double Inu[], double Taunu[], double nu_em[], size_t nbnu, double dsem, double coord_ph[8], double coord_obj[8]=NULL) const =delete
double | deltaMax () const
| Get delta_max_.
virtual double | deltaMax (double const pos[8], double delta_max_external) const
void | deltaMax (double h1)
virtual double | deltaMax (double *coord)
virtual double | deltaMax (double coord[8])
| Get max step constraint for adaptive integration.
virtual void | spectrum (SmartPointer< Spectrum::Generic >)
| Set spectrum_.
virtual SmartPointer< Spectrum::Generic > | spectrum () const
| Get spectrum_.
virtual void | opacity (SmartPointer< Spectrum::Generic >)
| Set opacity_.
virtual SmartPointer< Spectrum::Generic > | opacity () const
| Get opacity_.
double | radius () const
| Get radius_ in geometrical units.
virtual void | radius (double)
| Set radius_ in geometrical units.
double | radius (std::string const &) const
| Get radius_ in specified unit.
virtual void | radius (double, std::string const &)
| Set radius_ in specified unit.
double | deltaMaxOverRadius () const
| Get dltmor_.
virtual void | deltaMaxOverRadius (double f)
| Set dltmor_.
double | deltaMaxOverDistance () const
| Get dltmod_.
virtual void | deltaMaxOverDistance (double f)
| Set dltmod_.
bool | isotropic () const
void | isotropic (bool)
double | alpha () const
void | alpha (double)
virtual double | operator() (double const data[])=0
| The actual function.
virtual double | emission (double nu_em, double dsem, double coord_ph[8], double coord_obj[8]=NULL) const =delete
| Obsolete, update your code;.
virtual void | emission (double Inu[], double const nu_em[], size_t nbnu, double dsem, state_t const &coord_ph, double const coord_obj[8]=NULL) const
| Specific intensity Iν for several values of νem.
virtual void | emission (double Inu[], double nu_em[], size_t nbnu, double dsem, double coord_ph[8], double coord_obj[8]=NULL) const =delete
| Obsolete, update your code.
virtual double | integrateEmission (double nu1, double nu2, double dsem, state_t const &c_ph, double const c_obj[8]=NULL) const
| ∫ν1ν2 Iν dν (or jν)
virtual double | integrateEmission (double nu1, double nu2, double dsem, double c_ph[8], double c_obj[8]=NULL) const =delete
| Obsolete, update your code.
virtual void | integrateEmission (double *I, double const *boundaries, size_t const *chaninds, size_t nbnu, double dsem, state_t const &cph, double const *co) const
| ∫ν1ν2 Iν dν (or jν)
virtual void | integrateEmission (double *I, double const *boundaries, size_t const *chaninds, size_t nbnu, double dsem, double *cph, double *co) const =delete
| Obsolete, update your code.
virtual double | transmission (double nuem, double dsem, state_t const &coord_ph, double const coord_obj[8]) const
| Transmission: exp( αν * dsem ).
virtual double | transmission (double nuem, double dsem, state_t const &coord) const =delete
| Obsolete, update your code.
virtual double | transmission (double nuem, double dsem, double coord[8]) const =delete
| Obsolete, update your code.
virtual void | safetyValue (double val)
| Set Standard::safety_value_.
virtual double | safetyValue () const
| Get Standard::safety_value_.
double | deltaInObj () const
| Get Generic::delta_inobj_.
void | deltaInObj (double val)
| Set Generic::delta_inobj_.
virtual int | Impact (Gyoto::Photon *ph, size_t index, Astrobj::Properties *data=NULL)
| Does a photon at these coordinates impact the object?
virtual double | giveDelta (double coord[8])
| Maximum δ inside object.
| GYOTO_OBJECT_ACCESSORS_UNIT (deltaMaxInsideRMax)
void | opticallyThin (bool flag)
| Set whether the object is optically thin.
bool | opticallyThin () const
| Query whether object is optically thin.
void | showshadow (bool flag)
bool | showshadow () const
void | redshift (bool flag)
bool | redshift () const
virtual Gyoto::Quantity_t | getDefaultQuantities ()
| Which quantities to compute if know was requested.
virtual void | processHitQuantities (Photon *ph, state_t const &coord_ph_hit, double const *coord_obj_hit, double dt, Astrobj::Properties *data) const
| Fills Astrobj::Properties.
virtual void | processHitQuantities (Photon *ph, double *coord_ph_hit, double *coord_obj_hit, double dt, Astrobj::Properties *data) const =delete
Eigen::Matrix4d | Omatrix (double alphanu[4], double rnu[3], double Chi, double dsem) const
Eigen::Matrix4d | Omatrix (double alphaInu, double alphaQnu, double alphaUnu, double alphaVnu, double rQnu, double rUnu, double rVnu, double Chi, double dsem) const
Eigen::Matrix4d | Omatrix (double alphanu[4], double rnu[3], double sin2Chi, double cos2Chi, double dsem) const
Eigen::Matrix4d | Omatrix (double alphaInu, double alphaQnu, double alphaUnu, double alphaVnu, double rQnu, double rUnu, double rVnu, double sin2Chi, double cos2Chi, double dsem) const
Eigen::Matrix4d | Pmatrix (double alphaInu, double alphaQnu, double alphaUnu, double alphaVnu, double rQnu, double rUnu, double rVnu, double sin2Chi, double cos2Chi, double dsem) const
Eigen::Vector4d | rotateJs (double jInu, double jQnu, double jUnu, double jVnu, double sin2Chi, double cos2Chi) const
Eigen::Vector4d | rotateJs (double jInu, double jQnu, double jUnu, double jVnu, double Chi) const
double | getChi (double const fourvect[4], state_t const &cph, double const vel[4], bool elec=false) const
void | getSinCos2Chi (double const fourvect[4], state_t const &cph, double const vel[4], double *sin2Chi, double *cos2Chi, bool elec=false) const
void | computeB4vect (double B4vect[4], std::string const magneticConfig, double const co[8], state_t const &cph) const
void | computeB4vect_ipole (double B4vect[4], std::string const magneticConfig, double const co[8], state_t const &cph, double spin) const
double | interpolate (int const N, double *const array, double *const Xq, double **const X, int *const X_params, std::string const *cond_limits) const
double | interpolate (int const N, double *const array, double *const Xq, double **const X_params, std::string const *cond_limits) const
void | incRefCount ()
| Increment the reference counter. Warning: Don't mess with the counter.
int | decRefCount ()
| Decrement the reference counter and return current value. Warning: Don't mess with the counter.
int | getRefCount ()
| Get the current number of references.
virtual bool | isThreadSafe () const
| Whether this class is thread-safe.
virtual void | set (Property const &p, Value val)
| Set Value of a Property.
virtual void | set (Property const &p, Value val, std::string const &unit)
| Set Value (expressed in unit) of a Property.
virtual void | set (std::string const &pname, Value val)
| Set Value of a Property.
virtual void | set (std::string const &pname, Value val, std::string const &unit)
| Set Value (expressed in unit) of a Property.
virtual Value | get (Property const &p) const
| Get Value of a Property.
virtual Value | get (std::string const &pname) const
| Get Value of a Property.
virtual Value | get (Property const &p, std::string const &unit) const
| Get Value of a Property, converted to unit.
virtual Value | get (std::string const &pname, std::string const &unit) const
| Get Value of a Property, converted to unit.
Property const * | property (std::string const pname) const
| Find property by name.
virtual void | fillElement (Gyoto::FactoryMessenger *fmp) const
| Fill the XML element for this Object.
std::string | describeProperty (Gyoto::Property const &p) const
| Format desrciption for a property.
void | help () const
| Print (to stdout) some help on this class.
virtual std::string | kind () const
| Get kind_.
size_t | getImin () const
| Get imin_.
size_t | getImax () const
| Get imax_.
size_t | getI0 () const
| Get i0_.
void | initCoord (std::vector< double > const &)
std::vector< double > | initCoord () const
virtual void | setInitCoord (const double coord[8], int dir, double const Ephi[4], double const Etheta[4])
| Set Initial coordinate.
virtual void | setInitCoord (double const pos[4], double const vel[3], int dir=0)
| Set initial coordinate.
virtual void | setPosition (double const pos[4])
| Set initial 4-position.
virtual void | setVelocity (double const vel[3])
| Set initial 3-velocity.
void | reset ()
| Forget integration, keeping initial contition.
void | reInit ()
| Reset and recompute particle properties.
void | integrator (std::string const &type)
| Set the integrator.
std::string | integrator () const
| Describe the integrator used by state_.
void | integ31 (bool integ)
| Set the integrator kind to 3+1 or 4D.
bool | integ31 () const
| Get the kind of geodesic equation integrated by state_.
double | deltaMin () const
| Get delta_min_.
void | deltaMin (double h1)
| Set delta_min_.
void | absTol (double)
| Set abstol_.
double | absTol () const
| Get abstol_.
void | relTol (double)
| Set reltol_.
double | relTol () const
| Get reltol_.
void | maxCrossEqplane (double)
| Set #maxCrosEqplane_.
double | maxCrossEqplane () const
| Get maxCrossEqplane_.
double | deltaMaxOverR () const
| Get delta_max_over_r_.
void | deltaMaxOverR (double t)
| Set delta_max_over_r_.
void | delta (const double delta)
| Expand memory slots for polarization vectors.
void | delta (double, const std::string &unit)
| Set delta_ in specified units.
double | delta () const
| Get delta_.
double | delta (const std::string &unit) const
| Get delta_ in specified units.
double | tMin () const
| Get tmin_.
double | tMin (const std::string &unit) const
| Get tmin_ in specified unit.
void | tMin (double tlim)
| Set tmin_.
void | tMin (double, const std::string &unit)
| Set tmin_ in specified unit.
void | adaptive (bool mode)
| Set adaptive_.
bool | adaptive () const
| Get adaptive_.
void | secondary (bool sec)
| Set secondary_.
bool | secondary () const
| Get secondary_.
void | parallelTransport (bool pt)
| Set parallel_transport_.
bool | parallelTransport () const
| Get parallel_transport_.
void | maxiter (size_t miter)
| Set maxiter_.
size_t | maxiter () const
| Get maxiter_.
double const * | getCst () const
| Returns the worldline's cst of motion (if any).
void | setCst (double const *cst, size_t const ncsts)
| Set Metric-specific constants of motion.
void | constantsOfMotion (std::vector< double > const cstv)
| Set Metric-specific constants of motion.
std::vector< double > | constantsOfMotion () const
| Return a copy of the Metric-specific constants of motion.
void | getInitialCoord (std::vector< double > &dest) const
| Get initial coordinates + base vectors.
void | getCoord (size_t index, Gyoto::state_t &dest) const
| Get coordinates+base vectors corresponding to index.
void | getCoord (size_t index, Gyoto::state_t &dest)
| Get coordinates+base vectors corresponding to index.
void | getCoord (double date, Gyoto::state_t &dest, bool proper=false)
| Get coordinates+base vectors corresponding to date dest[0].

void

getCoord (double const *const dates, size_t const n_dates, double *const x1dest, double *const x2dest, double *const x3dest, double *const x0dot=NULL, double *const x1dot=NULL, double *const x2dot=NULL, double *const x3dot=NULL, double *ep0=NULL, double *ep1=NULL, double *ep2=NULL, double *ep3=NULL, double *et0=NULL, double *et1=NULL, double *et2=NULL, double *et3=NULL, double *otime=NULL, bool proper=false)

| Get 8-coordinates for specific dates.
void | getCoord (double *x0, double *x1, double *x2, double *x3) const
| Get all computed positions.
void | getCartesianPos (size_t index, double dest[4]) const
| Get Cartesian expression of 4-position at index.
virtual void | xStore (size_t ind, state_t const &coord)=delete
| Obsolete, update your code.
virtual void | xStore (size_t ind, double const coord[8])=delete
| Obsolete, update your code.
virtual void | xFill (double tlim, bool proper=false)
| Fill x0, x1... by integrating the Worldline from previously set inittial condition to time tlim.
size_t | get_nelements () const
| Get number of computed dates.
void | get_t (double *dest) const
| Get computed dates.
void | get_tau (double *dest) const
| Get computed proper times or values of the affine parameter.
void | get_xyz (double *x, double *y, double *z) const
| Get 3-position in cartesian coordinates for computed dates.
void | checkPhiTheta (double coord[8]) const
| Bring θ in [0,Π] and φ in [0,2Π].
void | getSkyPos (SmartPointer< Screen > screen, double *dalpha, double *ddellta, double *dD) const
| Get computed positions in sky coordinates.
void | get_dot (double *x0dot, double *x1dot, double *x2dot, double *x3dot) const
| Get computed 4-velocities.
void | get_prime (double *x1prime, double *x2prime, double *x3prime) const
| Get computed 3-velocities.
void | save_txyz (char *fichierxyz) const
| Save in a file.
void | save_txyz (char *const filename, double const t1, double const mass_sun, double const distance_kpc, std::string const unit, SmartPointer< Screen > sc=NULL)
| Save, converted.

## Public Attributes

| GYOTO_WORLDLINE
int | stopcond
| Whether and why integration is finished.

## Static Public Attributes

static GYOTO_OBJECT Property const | properties []

## Protected Member Functions

virtual double | emission (double nu_em, double dsem, state_t const &cp, double const co[8]=NULL) const
| Emission is determined by spectrum_ and opacity_.
virtual double | integrateEmission (double nu1, double nu2, double dsem, state_t const &c_ph, double const *c_obj=NULL) const
virtual double | transmission (double nuem, double dsem, state_t const &, double const *) const
| Transmission is determined by opacity_.
virtual void | kind (const std::string)
| Set kind_.
virtual void | xAllocate ()
| Allocate x0, x1 etc. with default size.
virtual void | xExpand (double *&x, int dir)
| Expand one array to hold more elements.
virtual void | eAllocate ()
| Allocate ep0_ ... et3_.
virtual void | eDeallocate ()
| Deallocate ep0_ ... et3_.
virtual void | eExpand (int dir)
virtual void | tell (Gyoto::Hook::Teller *)
| This is how a Teller tells.

## Protected Attributes

double | tmin_
| Minimum date to consider on the underlying Star orbit.
double | tmax_
| Maximum date to consider on the underlying Star orbit.
double * | x_
| Cartesian x.
double * | y_
| Cartesian y.
double * | z_
| Cartesian z.
double | radius_
| sphere radius [geometrical units]
bool | isotropic_
| if 1, then emission just returns 1
SmartPointer< Spectrum::Generic > | spectrum_
| sphere emission law
SmartPointer< Spectrum::Generic > | opacity_
| if optically thin, opacity law
double | dltmor_
| see deltaMax(double*)
double | dltmod_
| see deltaMax(double*)
double | critical_value_
| See operator()(double const coord[4]).
double | safety_value_
| See operator()(double const coord[4]).
double | delta_inobj_
| Constant value of the integration step inside object, in units of the compact object's mass M.
SmartPointer< Gyoto::Metric::Generic > | gg_
| The Metric in this end of the Universe.
double | rmax_
| Maximum distance to the center of the coordinate system [geometrical units].
double | deltamaxinsidermax_
| Maximum Photon integration step inside rmax_ [geometrical units].
bool | flag_radtransf_
| 1 if radiative transfer inside Astrobj, else 0
int | shadow_
| 1 to highlight the shadow region in the image
int | noredshift_
| 1 to impose redshift factor g = 1
std::string | kind_
| The "kind" that is output in the XML entity.
std::vector< std::string > | plugins_
| The plug-ins that needs to be loaded to access this instance's class.
SmartPointer< Gyoto::Metric::Generic > | metric_
| The Gyoto::Metric in this part of the universe.
double * | tau_
| proper time or affine parameter
double * | x0_
| t or T
double * | x1_
| r or x
double * | x2_
| θ or y
double * | x3_
| φ or z
double * | x0dot_
| tdot or Tdot
double * | x1dot_
| rdot or xdot
double * | x2dot_
| θdot or ydot
double * | x3dot_
| φdot or zdot
double * | ep0_
double * | ep1_
| Coordinate of first base vector to parallel transport.
double * | ep2_
| Coordinate of first base vector to parallel transport.
double * | ep3_
| Coordinate of first base vector to parallel transport.
double * | et0_
| Coordinate of first base vector to parallel transport.
double * | et1_
| Coordinate of Second base vector to parallel transport.
double * | et2_
| Coordinate of Second base vector to parallel transport.
double * | et3_
| Coordinate of Second base vector to parallel transport.
size_t | x_size_
| Coordinate of Second base vector to parallel transport.
size_t | imin_
| Minimum index for which x0_, x1_... have been computed.
size_t | i0_
| Index of initial condition in array.
size_t | imax_
| Maximum index for which x0_, x1_... have been computed.
bool | adaptive_
| Whether integration should use adaptive delta.
bool | secondary_
| Experimental: choose 0 to compute only primary image.
bool | parallel_transport_
| Whether to parallel transport a local triad.
double | delta_
| Initial integrating step.
double * | cst_
| Worldline's csts of motion (if any).
size_t | cst_n_
| Number of constants of motion.
int | wait_pos_
| Hack in setParameters().
double * | init_vel_
| Hack in setParameters().
size_t | maxiter_
| Maximum number of iterations when integrating.
double | delta_min_
| Minimum integration step for the adaptive integrator.
double | delta_max_
| Maximum integration step for the adaptive integrator.
double | delta_max_over_r_
| Numerical tuning parameter.
double | abstol_
| Absolute tolerance of the integrator.
double | reltol_
| Absolute tolerance of the integrator.
double | maxCrossEqplane_
| Maximum number of crossings of equatorial plane.
SmartPointer< Worldline::IntegState::Generic > | state_
| An object to hold the integration state.

## Private Member Functions

double | interp1d (double const x, double const y0, double const y1) const
double | interpNd (int const N, double *const Xq, double **const X, double *const Y, std::string const *cond_limit) const
int | getIndice (double &xq, std::string const cond_limit, double const X_params[3], double *const X=NULL) const

## Private Attributes

SmartPointer< Spectrum::ThermalSynchrotron > | spectrumThermalSynch_
int | __defaultfeatures
| Whether some virtual methods are implemented.
int | refCount
| Reference counter.
pthread_mutex_t | mutex_
| A mutex.

## Friends

class | Gyoto::SmartPointer< Gyoto::Astrobj::StarTrace >

## Detailed Description

Like a Star that would be on all points of its orbit at all time.

StarTrace inherits all the members and methods from Star. It has two additional members, tmin_ and tmax_, which specify the time interval of the Star's orbit that is to be considerred illuminated.

A StarTrace is not (necessarily) continuous: the Star is considerred to be present at all the locations computed by xFill(), meaning that if the integration step is large compared to radius_, the object will be a collection of discrete blobs. To ensure continuity, one should use a non-adaptive step and specify a reasonable step. Computation is also faster in optically thick mode.

<Astrobj kind="StarTrace">
...
<TMin> 600 </TMin>
<TMax> 600 </TMax>
<NonAdaptive/>
<Radius> 1 </Radius>
<Delta> 1 </Delta>
</Astrobj>
Gyoto::Astrobj::StarTrace::TMin
double TMin() const
Get tmin_.
Gyoto::Astrobj::StarTrace::TMax
double TMax() const
Get tmax_.
Gyoto::Object::kind
virtual void kind(const std::string)
Set kind_.
Gyoto::Astrobj
Access to astronomical objects.
Definition GyotoAstrobj.h:49

## Member Typedef Documentation

## Subcontractor_t

typedef Gyoto::SmartPointer< Gyoto::SmartPointee > Gyoto::SmartPointee::Subcontractor_t(Gyoto::FactoryMessenger *, std::vector< std::string > const &)

inherited

A subcontractor builds an object upon order from the Factory.

Various classes need to provide a subcontractor to be able to instantiate themselves upon order from the Factory. A subcontractor is a function (often a static member function) which accepts a pointer to a FactoryMessenger as unique parameter, communicates with the Factory using this messenger to read an XML description of the object to build, and returns this objet. SmartPointee::Subcontractor_t* is just generic enough a typedef to cast to and from other subcontractor types: Astrobj::Subcontractor_t, Metric::Subcontractor_t, Spectrum::Subcontractor_t. A subcontractor needs to be registered using the relevant Register() function: Astrobj::Register(), Metric::Register(), Spectrum::Register().

## Constructor & Destructor Documentation

## StarTrace() [1/2]

Gyoto::Astrobj::StarTrace::StarTrace | ( | SmartPointer< Metric::Generic > | gg,
|  | double | radius,
|  | double const | pos[4],
|  | double const | v[3] )

Create Star object and set initial condition.

Parameters

  gg | Gyoto::SmartPointer to the Gyoto::Metric in this part of the Universe
  radius | star radius
  pos | initial 4-position
  v | initial 3-velocity

## StarTrace() [2/2]

Gyoto::Astrobj::StarTrace::StarTrace | ( |  | ) |

Default constructor.

Create Star object with undefined initial conditions. One needs to set the coordinate system, the metric, and the initial position and velocity before integrating the orbit. setInititialCondition() can be used for that.

## Member Function Documentation

## checkPhiTheta()

void Gyoto::Worldline::checkPhiTheta | ( | double | coord[8] | ) | const

inherited

Bring θ in [0,Π] and φ in [0,2Π].

checkPhiTheta() Modifies coord if the corrdinates are spherical-like so that coord[2]=theta is in [0,pi] and coord[3]=phi is in [0,2pi]. Important to use in all astrobj in spherical coordinates to prevent "z-axis problems".

## className()

virtual std::string Gyoto::Astrobj::StarTrace::className | ( |  | ) | const

virtual

"StarTrace"

Reimplemented from Gyoto::Astrobj::Star.

## className_l()

virtual std::string Gyoto::Astrobj::StarTrace::className_l | ( |  | ) | const

virtual

"startrace"

Reimplemented from Gyoto::Astrobj::Star.

## clone()

virtual StarTrace * Gyoto::Astrobj::StarTrace::clone | ( |  | ) | const

virtual

Cloner.

This method must be implemented by the various Astrobj::Generic subclasses in order to support cloning:

SmartPointer<Astrobj> deep_copy = original->clone();
Gyoto::SmartPointer
Pointers performing reference counting.
Definition GyotoSmartPointer.h:135

Cloning is necessary for multi-threading, recommended for interaction with the Yorick plug-in etc.

Implementing it is very straightforward, as long as the copy constructor Generic(const Generic& ) has been implemented:

MyAstrobj* MyAstrobj::clone() const { return new MyAstrobj(*this); }

Reimplemented from Gyoto::Astrobj::Star.

## computeB4vect()

void Gyoto::Astrobj::Generic::computeB4vect | ( | double | B4vect[4],
|  | std::string const | magneticConfig,
|  | double const | co[8],
|  | state_t const & | cph ) const

inherited

Compute the magnetic field 4-vector at a given position and a given configuration

Parameters

  B4vect | the output 4-vector magnetic field
  magneticConfig | string which determine the wanted configuration ('Radial', 'Azimuthal', 'Vertical')
  co | coordinate of the object which also contain its velocity
  cph | coordinate of the photon

## constantsOfMotion() [1/2]

std::vector< double > Gyoto::Worldline::constantsOfMotion | ( |  | ) | const

inherited

Return a copy of the Metric-specific constants of motion.

This function return a copy of the constants of motion. getCst() can be used to retrieve a pointer to the actual array used internally which is slightly more efficient for read-only access.

## constantsOfMotion() [2/2]

void Gyoto::Worldline::constantsOfMotion | ( | std::vector< double > const | cstv | ) |

inherited

Set Metric-specific constants of motion.

The will (re)allocate Worldline::cst_, copy cst into it, and set Worldline::cst_n_.

This is the same as getCst using a vector instead of a C-style array.

## delta()

void Gyoto::Worldline::delta | ( | const double | delta | ) |

inherited

Expand memory slots for polarization vectors.

Assignment to another Worldline Set delta_

## deltaInObj()

double Gyoto::Astrobj::Standard::deltaInObj | ( |  | ) | const

inherited

Get Generic::delta_inobj_.

Get the constant integration step inside the astrobj

Returns
  delta_inobj_ in geometrical units

## deltaMax() [1/4]

virtual double Gyoto::Astrobj::Generic::deltaMax | ( | double | coord[8] | ) |

virtual inherited

Get max step constraint for adaptive integration.

Parameters

  [in] | coord | position

Returns
  max step to find this object reliably

Reimplemented in Gyoto::Astrobj::Complex, and Gyoto::Astrobj::EquatorialHotSpot.

## deltaMax() [2/4]

virtual double Gyoto::Astrobj::UniformSphere::deltaMax | ( | double * | coord | ) |

virtual inherited

Parameters

  [in] | coord | current photon position

Returns
  max( dltmor_*radius_, dltmod_*operator()(double coord[]) )

Reimplemented from Gyoto::Astrobj::UniformSphere.

## deltaMax() [3/4]

virtual double Gyoto::Worldline::deltaMax | ( | double const | pos[8],
|  | double | delta_max_external ) const

virtual inherited

Get delta max at a given position

Parameters

  [in] | pos | 4-position
  [in] | delta_max_external | external constraint on delta_max

Returns
  the smallest value between delta_max_, delta_max_external, and R*delta_max_over_r_ where R is pos[1] in spherical coordinates and max(x1, x2, x3) in Cartesian coordinates.

Reimplemented from Gyoto::Worldline.

## deltaMax() [4/4]

void Gyoto::Worldline::deltaMax | ( | double | h1 | ) |

inherited

Set delta_max_

## describeProperty()

std::string Gyoto::Object::describeProperty | ( | Gyoto::Property const & | p | ) | const

inherited

Format desrciption for a property.

Returns a string containing the name(s) and type of the property, as well as whether it supports unit.

## eAllocate()

virtual void Gyoto::Worldline::eAllocate | ( |  | ) |

protected virtual inherited

Allocate ep0_ ... et3_.

Allocate memory for polarization vectors

## eDeallocate()

virtual void Gyoto::Worldline::eDeallocate | ( |  | ) |

protected virtual inherited

Deallocate ep0_ ... et3_.

Deallocate memory for polarization vectors

## eExpand()

virtual void Gyoto::Worldline::eExpand | ( | int | dir | ) |

protected virtual inherited

Call xExpand(double * &x, int dir) on #ep0_, ep1_ etc.

## emission() [1/2]

virtual void Gyoto::Astrobj::Generic::emission | ( | double | Inu[],
|  | double const | nu_em[],
|  | size_t | nbnu,
|  | double | dsem,
|  | state_t const & | coord_ph,
|  | double const | coord_obj[8] = NULL ) const

virtual inherited

Specific intensity Iν for several values of νem.

Called by the default implementation for processHitQuantities().

emission() computes the intensity Iν emitted by the small volume of length dsem. It should take self-absorption along dsem into account.

Same as emission(double nu_em, double dsem, double coord_ph[8], double coord_obj[8]=NULL) const looping on several values of nu_em.

Parameters

  Inu[nbnu] | Output (must be set to a previously allocated array of doubles)
  nu_em[nbnu] | Frequencies at emission
  nbnu | Size of Inu[] and nu_em[]
  dsem | Length over which to integrate inside the object
  coord_ph | Photon coordinate
  coord_obj | Emitter coordinate at current photon position

Returns
  Iν or dIν [W m-2 sr-2]

Reimplemented in Gyoto::Astrobj::Python::Standard, and Gyoto::Astrobj::Python::ThinDisk.

## emission() [2/2]

virtual double Gyoto::Astrobj::UniformSphere::emission | ( | double | nu_em,
|  | double | dsem,
|  | state_t const & | cp,
|  | double const | co[8] = NULL ) const

protected virtual inherited

Emission is determined by spectrum_ and opacity_.

Reimplemented from Gyoto::Astrobj::Generic.

Reimplemented in Gyoto::Astrobj::InflateStar.

## fillElement()

virtual void Gyoto::Object::fillElement | ( | Gyoto::FactoryMessenger * | fmp | ) | const

virtual inherited

Fill the XML element for this Object.

The base implementation simply calls fillProperty() for each Property defined for the Object.

Derived classes should avoid overriding fillElement(). It may make sense occasionally, e.g. to make sure that the metric is output first.

To customize how a given Property is rendered, it is better to override fillProperty().

If this method is overridden, the implementation should in general call fillElement() on the direct base.

Reimplemented in Gyoto::Astrobj::Complex, Gyoto::Metric::Complex, Gyoto::Scenery, and Gyoto::Spectrometer::Complex.

## fillProperty()

virtual void Gyoto::Astrobj::Star::fillProperty | ( | Gyoto::FactoryMessenger * | fmp,
|  | Property const & | p ) const

virtual inherited

Output a single Property to XML.

The base implementation decides what to do based on the p.type. The format matches how setParameters() an setParameter() would interpret the XML descition.

Overriding this method should be avoided, but makes sense in some cases (for instance Screen::fillProperty() selects a different unit for Distance based on its magnitude, so that stellar sizes are expressed in solar radii while smaller sizes can be expressed in meters and larger sizes in parsecs).

Overriding implementation should fall-back on calling the implementation in the direct parent class:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual void fillProperty(Gyoto::FactoryMessenger *fmp,
Property const &p) const ;
};
void B::fillProperty(Gyoto::FactoryMessenger *fmp,
Property const &p) const {
if (name=="Duff") fmp->doSomething();
else A::fillProperty(fmp, p);
}
Gyoto::FactoryMessenger
Factory / SmartPointee::Subcontractor_t interface.
Definition GyotoFactoryMessenger.h:92
Gyoto::Object
Object with properties.
Definition GyotoObject.h:152
Gyoto::Property
Property that can be set and got using standard methods.
Definition GyotoProperty.h:608

Reimplemented from Gyoto::Object.

## getCartesian()

virtual void Gyoto::Astrobj::Star::getCartesian | ( | double const *const | dates,
|  | size_t const | n_dates,
|  | double *const | x,
|  | double *const | y,
|  | double *const | z,
|  | double *const | xprime = NULL,
|  | double *const | yprime = NULL,
|  | double *const | zprime = NULL )

virtual inherited

Get the 6 Cartesian coordinates for specific dates.

This method is present in both the API of UniformSphere and Worldline. It is pure virtual in UniformSphere. The Star reimplementation is a trivial wrapper around Worldline::getCartesian().

Implements Gyoto::Astrobj::UniformSphere.

## getChi()

double Gyoto::Astrobj::Generic::getChi | ( | double const | fourvect[4],
|  | state_t const & | cph,
|  | double const | vel[4],
|  | bool | elec = false ) const

inherited

Get Chi angle. Return the angle between the parallel transported observer polarization basis (Ephi,Etheta) and the Stokes basis in the rest frame of the emitter defined by the 4-vector magnetic/electric field.

Parameters

  fourvect | 4-vector magnetic/electric field depending on elec (false/true)
  cph | Photon coordinate, must contain the Ephi and Etheta vectors i.e. size(cph)==16
  vel | Fluid velocity at the photon coordinate

## getCoord() [1/5]

void Gyoto::Worldline::getCoord | ( | double * | x0,
|  | double * | x1,
|  | double * | x2,
|  | double * | x3 ) const

inherited

Get all computed positions.

Get all the pre-computed 8 coordinates (e.g. thanks to a prior call to xFill()) of this worldline.

## getCoord() [2/5]

void Gyoto::Worldline::getCoord | ( | double const *const | dates,
|  | size_t const | n_dates,
|  | double *const | x1dest,
|  | double *const | x2dest,
|  | double *const | x3dest,
|  | double *const | x0dot = NULL,
|  | double *const | x1dot = NULL,
|  | double *const | x2dot = NULL,
|  | double *const | x3dot = NULL,
|  | double * | ep0 = NULL,
|  | double * | ep1 = NULL,
|  | double * | ep2 = NULL,
|  | double * | ep3 = NULL,
|  | double * | et0 = NULL,
|  | double * | et1 = NULL,
|  | double * | et2 = NULL,
|  | double * | et3 = NULL,
|  | double * | otime = NULL,
|  | bool | proper = false )

inherited

Get 8-coordinates for specific dates.

The coordinates will be computed using the integrator, so they will be as accurate as possible. Some heuristics are used to speed up the process and it is presumably faster to call this routine with a sorted list of dates. The line will be integrated further as required. An error will be thrown if it is not possible to reach a certain date.

Parameters

  [in] | dates | the list of dates for which the coordinates are to be computed in proper time or affine parameter if #proper is true or in coordinate time if #proper is false (default);
  [in] | n_dates | the number of dates to compute ;
  [out] | x1dest,x2dest,x3dest,x0dot,x1dot,x2dot,x3dot | arrays in which to store the result. These pointer may be set to NULL to retrieve only part of the information. They must be pre-allocated.
  [out] | ephi0,ephi1,ephi2,ephi3,etheta0,etheta1,etheta2,etheta3 | arrays in which to store the ephi and etheta (parallel transport case). These pointer may be set to NULL to retrieve only part of the information. They must be pre-allocated.
  [out] | otime | array in which to store the other time: coordinate time if #proper, else proper time or affine parameter.
  [in] | proper | bool: whether #dates is proper time (or affine parameter) or coordinate time.

## getCoord() [3/5]

void Gyoto::Worldline::getCoord | ( | double | date,
|  | Gyoto::state_t & | dest,
|  | bool | proper = false )

inherited

Get coordinates+base vectors corresponding to date dest[0].

Depending on the value of parallel_transport_, get position (xi_), velocity (xidot_) and possibly other triad vectors (epi_ and eti_). coord is resized to the right number of elements.

## getCoord() [4/5]

void Gyoto::Worldline::getCoord | ( | size_t | index,
|  | Gyoto::state_t & | dest )

inherited

Get coordinates+base vectors corresponding to index.

We need this non-const implementation to allow the const, size_t and the non-const, double implementations to coexist.

## getCoord() [5/5]

void Gyoto::Worldline::getCoord | ( | size_t | index,
|  | Gyoto::state_t & | dest ) const

inherited

Get coordinates+base vectors corresponding to index.

Depending on the value of parallel_transport_, get position (xi_), velocity (xidot_) and possibly other triad vectors (epi_ and eti_). coord is resized to the right number of elements.

## getCst()

double const * Gyoto::Worldline::getCst | ( |  | ) | const

inherited

Returns the worldline's cst of motion (if any).

Return pointer to array holding the previously set Metric-specific constants of motion.

This function returns a pointer to the actual storage location and should be handled with care. std::vector<double> Worldline:constantsOfMotion() const provides a convenient way to retrieve a copy of the content.

## getDefaultQuantities()

virtual Gyoto::Quantity_t Gyoto::Astrobj::Generic::getDefaultQuantities | ( |  | ) |

virtual inherited

Which quantities to compute if know was requested.

Return a Gyoto::Quantity_t suitable as input to Gyoto::Scenery::setRequestedQuantities() to set de default quantities to compute for this object. The default of these defaults GYOTO_QUANTITY_INTENSITY.

Reimplemented in Gyoto::Astrobj::PageThorneDisk.

## getIndice()

int Gyoto::Astrobj::Generic::getIndice | ( | double & | xq,
|  | std::string const | cond_limit,
|  | double const | X_params[3],
|  | double *const | X = NULL ) const

private inherited

Function that return the closest indice of the query value on an axis.

Parameters

  xq | query value on the axis. Could be modified in case of periodic boundary condition.
  cond_limit | boundary conditions that will be applied to the axis.
  X_params[3] | array which contain the minimum value, the maximum value and the length of the axe.
  X | (optional) array which contains the value of the axis points. Usefull for not linearly spaced axis.

## getInitialCoord()

void Gyoto::Worldline::getInitialCoord | ( | std::vector< double > & | dest | ) | const

inherited

Get initial coordinates + base vectors.

Depending on the size of dest and on the value of parallel_transport_, get position (xi_), velocity (xidot_) and possibly other triad vectors (epi_ and eti_).

## getMass()

virtual double Gyoto::Astrobj::Star::getMass | ( |  | ) | const

virtual inherited

Return 1.

The mass of a Star is always 1. Stars do not perturb the metric. The only relevant point is that Stars are massive particules, their exact mass is of no importance.

Implements Gyoto::Worldline.

## getProperties()

virtual Property const * Gyoto::Astrobj::StarTrace::getProperties | ( |  | ) | const

virtual

Get list of properties.

This method is declared automatically by the GYOTO_OBJECT macro and defined automatically by the GYOTO_PROPERTY_END macro.

Reimplemented from Gyoto::Astrobj::Star.

## getSinCos2Chi()

void Gyoto::Astrobj::Generic::getSinCos2Chi | ( | double const | fourvect[4],
|  | state_t const & | cph,
|  | double const | vel[4],
|  | double * | sin2Chi,
|  | double * | cos2Chi,
|  | bool | elec = false ) const

inherited

Get the cosinus and sinus of 2*Chi angle. Chi being the angle between the parallel transported observer polarization basis (Ephi,Etheta) and the Stokes basis in the rest frame of the emitter defined by the 4-vector magnetic/electric field.

Parameters

  fourvect | 4-vector magnetic/electric field depending on elec (false/true)
  cph | Photon coordinate, must contain the Ephi and Etheta vectors i.e. size(cph)==16
  vel | Fluid velocity at the photon coordinate

## getVelocity()

virtual void Gyoto::Astrobj::Star::getVelocity | ( | double const | pos[4],
|  | double | vel[4] )

virtual inherited

Yield velocity of the center of the sphere.

Implements Gyoto::Astrobj::UniformSphere.

## giveDelta()

virtual double Gyoto::Astrobj::Standard::giveDelta | ( | double | coord[8] | ) |

virtual inherited

Maximum δ inside object.

Gives the requested integration step δt (in coordinate time t) between two neighboring points along a portion of geodesic inside an astrobj; the current implementation only considers a constant delta, equal to Standard::deltaInobj()

Parameters

  coord | input coordinate at which δt is given

Reimplemented in Gyoto::Astrobj::Python::Standard.

## help()

void Gyoto::Object::help | ( |  | ) | const

inherited

Print (to stdout) some help on this class.

Describe all properties that this instance supports.

## Impact()

virtual int Gyoto::Astrobj::Standard::Impact | ( | Gyoto::Photon * | ph,
|  | size_t | index,
|  | Astrobj::Properties * | data = NULL )

virtual inherited

Does a photon at these coordinates impact the object?

Impact() checks whether a Photon impacts the object between two integration steps of the photon's trajectory (those two steps are photon->getCoord(index, coord1) and photon->getCoord(index+1, coord2)). Impact returns 1 if the photon impacts the object between these two steps, else 0. In many cases of geometrically thick obects, the implementation Astrobj::Standard::Impact() will be fine.

Impact will call Generic::processHitQuantities() (which is virtual and may be re-implemented) to compute observable properties on demand: if the data pointer is non-NULL, the object will look in it for pointers to properties which apply to its kind. If a pointer to a property known to this object is present, then the property is computed and store at the pointed-to address. For instance, all objects know the "intensity" property. If data->intensity != NULL, the instensity is computed and stored in *data->intensity.

If data is non-NULL and only in this case, processHitQuantities() will also call ph->transmit() to update the transmissions of the Photon (see Photon::transmit(size_t, double)). This must not be done if data is NULL (see Astrobj::Complex::Impact() for an explanation).

Impact() may not extend the ph Worldline. The only two dates that are guaranteed to be defined are at indices index and index+1.

Parameters

  ph | Gyoto::Photon aimed at the object;
  index | Index of the last photon step;
  data | Pointer to a structure to hold the observables at impact.

Returns
  1 if impact, 0 if not.

Implements Gyoto::Astrobj::Generic.

Reimplemented in Gyoto::Astrobj::InflateStar, Gyoto::Astrobj::Plasmoid, and Gyoto::Astrobj::PolishDoughnut.

## integ31()

void Gyoto::Worldline::integ31 | ( | bool | integ | ) |

inherited

Set the integrator kind to 3+1 or 4D.

Initialize state_ to use the required geodesic equation.

## integrateEmission() [1/2]

virtual void Gyoto::Astrobj::Generic::integrateEmission | ( | double * | I,
|  | double const * | boundaries,
|  | size_t const * | chaninds,
|  | size_t | nbnu,
|  | double | dsem,
|  | state_t const & | cph,
|  | double const * | co ) const

virtual inherited

∫ν1ν2 Iν dν (or jν)

Like double integrateEmission(double nu1, double nu2, double dsem, double c_ph[8], double c_obj[8]) const for each Spectrometer channel.

Reimplemented in Gyoto::Astrobj::PolishDoughnut, Gyoto::Astrobj::Python::Standard, and Gyoto::Astrobj::Python::ThinDisk.

## integrateEmission() [2/2]

virtual double Gyoto::Astrobj::Generic::integrateEmission | ( | double | nu1,
|  | double | nu2,
|  | double | dsem,
|  | state_t const & | c_ph,
|  | double const | c_obj[8] = NULL ) const

virtual inherited

∫ν1ν2 Iν dν (or jν)

Compute the integral of emission() from ν1 to ν2. The default implementation is a numerical integrator which works well enough and is reasonably fast if emission() is a smooth function (i.e. no emission or absorption lines). If possible, it is wise to implement an analytical solution. It is used by processHitQuantities to compute the "BinSpectrum" quantity which is the most physical: it is the only quantity that can be actually measured directly by a real-life instrument.

Reimplemented in Gyoto::Astrobj::Python::Standard, Gyoto::Astrobj::Python::ThinDisk, and Gyoto::Astrobj::Torus.

## integrator()

void Gyoto::Worldline::integrator | ( | std::string const & | type | ) |

inherited

Set the integrator.

Initialize state_ to use the required integrator.

Parameters

  [in] | type | Either "Legacy" or (if GYOTO_HAVE_BOOST_INTEGRATORS) one of "runge_kutta_cash_karp54", "runge_kutta_fehlberg78", "runge_kutta_dopri5", "runge_kutta_cash_karp54_classic"

## interp1d()

double Gyoto::Astrobj::Generic::interp1d | ( | double const | x,
|  | double const | y0,
|  | double const | y1 ) const

private inherited

Function which returns the 1D linear interpolation.

Parameters

  x | the x query position along the linear function [0,1].
  y0 | the value of the array to be interpolated at the low position.
  y1 | the value of the array to be interpolated at the high position.

## interpNd()

double Gyoto::Astrobj::Generic::interpNd | ( | int const | N,
|  | double *const | Xq,
|  | double **const | X,
|  | double *const | Y,
|  | std::string const * | cond_limit ) const

private inherited

Function which returns the N- dimension interpolation on an N-dimensional cube

Parameters

  N | number of dimensions
  Xq | query position at which the interpolation should be done. 1D array with N elements.
  X[2**N][N] | 2D array that contains for the 2**N points of the N dimensional cube the associated axes values.
  Y[2**N] | 1D array that contain the value of the array to be interpolated at each points of the N-dimensional cube.
  cond_limit | 1D array of strings that set the boundary conditions that will be applied to each axes.

## interpolate() [1/2]

double Gyoto::Astrobj::Generic::interpolate | ( | int const | N,
|  | double *const | array,
|  | double *const | Xq,
|  | double **const | X,
|  | int *const | X_params,
|  | std::string const * | cond_limits ) const

inherited

N-dimensional linear interpolation function

Parameters

  N | number of dimensions
  array | array that should be interpolated. This array has to be a 1D array with the first dimension evolving the slowest
  Xq | query position at which the interpolation should be done. 1D array with N elements.
  X | 2D array containing the range of all the axes (for example : radius, \theta, \varphi) at which the array is knwon. Should be built as a pointer of pointers.
  X_params | 1D array that contain the length of each axes.
  cond_limits | 1D array of strings that set the boundary conditions that will be applied to each axes

## interpolate() [2/2]

double Gyoto::Astrobj::Generic::interpolate | ( | int const | N,
|  | double *const | array,
|  | double *const | Xq,
|  | double **const | X_params,
|  | std::string const * | cond_limits ) const

inherited

N-dimensional linear interpolation function

Parameters

  N | number of dimensions
  array | array that should be interpolated. This array has to be a 1D array with the first dimension evolving the slowest
  Xq | query position at which the interpolation should be done. 1D array with N elements.
  X_params[N][3] | 2D array that contain the minimum value, the maximum value and the length of each axes. The axes will be assumed to be linearly spaced.
  cond_limits | 1D array of strings that set the boundary conditions that will be applied to each axes.

## isThreadSafe()

virtual bool Gyoto::Object::isThreadSafe | ( |  | ) | const

virtual inherited

Whether this class is thread-safe.

Return True if this object is thread-safe, i.e. if an instance and its clone can be used in parallel threads (in the context of Scenery::raytrace()). Known objects which are not thread-safe include Lorene metrics and everything from the Python plug-in.

The default implementation considers that the class itself is thread safe and recurses into the declared properties to check whether they are safe too. Classes that abide to the Object/Property paradigm and are themselves thread-safe have nothing special to do.

Objects that clone children in their copy constructor that are not declared as properties must take these children into account.

Classes that are never thread-safe must declare it. It acn be easily done using GYOTO_OBJECT_THREAD_SAFETY in the class declaration and GYOTO_PROPERTY_THREAD_UNSAFE in the class definition.

## kind() [1/2]

virtual std::string Gyoto::Object::kind | ( |  | ) | const

virtual inherited

Get kind_.

Reimplemented in Gyoto::Spectrometer::Uniform.

## kind() [2/2]

virtual void Gyoto::Object::kind | ( | const std::string |  | ) |

protected virtual inherited

Set kind_.

kind(const std::string) is protected because, for most Objects, it should not be changed in runtime. Set kind_

## metric() [1/2]

virtual SmartPointer< Metric::Generic > Gyoto::Astrobj::Generic::metric | ( |  | ) | const

virtual

Get the Metric gg_.

Reimplemented from Gyoto::Astrobj::Star.

## metric() [2/2]

virtual void Gyoto::Astrobj::StarTrace::metric | ( | SmartPointer< Metric::Generic > |  | ) |

virtual

Set the Metric gg_.

Reimplemented from Gyoto::Astrobj::Star.

## Omatrix()

Eigen::Matrix4d Gyoto::Astrobj::Generic::Omatrix | ( | double | alphanu[4],
|  | double | rnu[3],
|  | double | Chi,
|  | double | dsem ) const

inherited

Omatrix() computes the exponential of the Mueller matrix which contains the absorption and Faraday coefficients and is used in the polarized radiative transfer equation.

Parameters

  Onu | output matrix (must be allocated previously)
  alphanu[4] | array containing the 4 absorption coefficients in the Stokes basis (I,Q,U,V)
  rnu[3] | array containing the 3 Faraday coefficients in the Stokes basis (Q,U,V)
  Chi | angle of rotation between the parallel transported observer polarization basis and the Stokes basis
  dsem | geometrical length in geometrical units

## operator()() [1/2]

virtual double Gyoto::Astrobj::StarTrace::operator() | ( | double const | coord[4] | ) |

virtual

Square distance to the center of the sphere.

Ensure integration does not miss the object

Reimplemented from Gyoto::Astrobj::UniformSphere.

## operator()() [2/2]

virtual double Gyoto::Functor::Double_constDoubleArray::operator() | ( | double const | data[] | ) |

pure virtual inherited

The actual function.

Implemented in Gyoto::Astrobj::ThinDisk.

## opticallyThin() [1/2]

bool Gyoto::Astrobj::Generic::opticallyThin | ( |  | ) | const

inherited

Query whether object is optically thin.

See opticallyThin(bool flag).

## opticallyThin() [2/2]

void Gyoto::Astrobj::Generic::opticallyThin | ( | bool | flag | ) |

inherited

Set whether the object is optically thin.

Set flag indicating that radiative transfer should be integrated, i.e. the object is to be considered optically thin.

Parameters

  flag | 1 if optically thin, 0 if optically thick.

## processHitQuantities()

virtual void Gyoto::Astrobj::Generic::processHitQuantities | ( | Photon * | ph,
|  | state_t const & | coord_ph_hit,
|  | double const * | coord_obj_hit,
|  | double | dt,
|  | Astrobj::Properties * | data ) const

virtual inherited

Fills Astrobj::Properties.

processHitQuantities fills the requested data in Impact. To use it, you need to call it in the Impact() method for your object in case of hit. It will fill Redshift, Intensity, Spectrum, BinSpectrum and update the Photon's transmission by calling Photon::transmit(), only if data==NULL.

You can overload it for your Astrobj. The generic implementation calls emission(), integrateEmission() and transmission() below.

Reimplemented in Gyoto::Astrobj::DynamicalDiskBolometric, Gyoto::Astrobj::PageThorneDisk, and Gyoto::Astrobj::ThinDiskProfile.

## property()

Property const * Gyoto::Object::property | ( | std::string const | pname | ) | const

inherited

Find property by name.

Look into the Property list for a Property whose name (or name_false, for a boolean Property) is pname. Return a const pointer to the first such property found, or NULL if none is found.

## radiativeQ() [1/2]

virtual void Gyoto::Astrobj::Generic::radiativeQ | ( | double | Inu[],
|  | double | Taunu[],
|  | double const | nu_em[],
|  | size_t | nbnu,
|  | double | dsem,
|  | state_t const & | coord_ph,
|  | double const | coord_obj[8] = NULL ) const

virtual inherited

emission and transmission together

Reimplemented in Gyoto::Astrobj::Blob, Gyoto::Astrobj::EquatorialHotSpot, Gyoto::Astrobj::FlaredDiskSynchrotron, Gyoto::Astrobj::Jet, Gyoto::Astrobj::Plasmoid, Gyoto::Astrobj::PolishDoughnut, Gyoto::Astrobj::SphericalAccretion, Gyoto::Astrobj::ThickDisk, and Gyoto::Astrobj::Torus.

## radiativeQ() [2/2]

virtual void Gyoto::Astrobj::Star::radiativeQ | ( | double * | Inu,
|  | double * | Qnu,
|  | double * | Unu,
|  | double * | Vnu,
|  | Eigen::Matrix4d * | Onu,
|  | double const * | nuem,
|  | size_t | nbnu,
|  | double | dsem,
|  | state_t const & | cph,
|  | double const * | co ) const

virtual inherited

Compute the increment of Stokes parameters and transmission matrix. Polarised version of RadiaveQ.

First function to be called for radiative quantities. If exist, i.e. implemented in an Astrobj, return the Stokes parameters emitted by the small volume of length dsem.

Warning :

- The basis used to determine the Stokes coefficients is different from the observer parallel transported polarisation basis. One should use getChi function to compute the angle between these two basis.
- The non polarized case must also be implemented in this function to avoid error.

See example in SimplePolarStar.C.

Parameters

  Inu[nbnu] | Output increment of intensity (must be set to a previously allocated array of doubles)
  Qnu[nbnu] | Output increment of Stokes parameter Q (must be set to a previously allocated array of doubles)
  Unu[nbnu] | Output increment of Stokes parameter U (must be set to a previously allocated array of doubles)
  Vnu[nbnu] | Output increment of Stokes parameter V (must be set to a previously allocated array of doubles)
  Onu[nbnu] | Output transmission (Eigen) matrix (must be set to a previously allocated array of Matrix4d)
  nu_em[nbnu] | Frequencies at emission
  nbnu | Size of nu_em[], Inu[], Qnu[], Unu[], Vnu[], and Onu[]
  dsem | Length over which to integrate inside the object
  cph | Photon coordinate
  co | Emitter coordinate at current photon position

Returns
  Increment of the Stokes parameters (I,Q,U,V) and local Transmission matrix (O).

Reimplemented from Gyoto::Astrobj::Generic.

## radius() [1/2]

virtual void Gyoto::Astrobj::UniformSphere::radius | ( | double |  | ) |

virtual inherited

Set radius_ in geometrical units.

Reimplemented in Gyoto::Astrobj::FixedStar.

## radius() [2/2]

virtual void Gyoto::Astrobj::UniformSphere::radius | ( | double | ,
|  | std::string const & | )

virtual inherited

Set radius_ in specified unit.

Reimplemented in Gyoto::Astrobj::FixedStar.

## rMax() [1/4]

virtual void Gyoto::Astrobj::Generic::rMax | ( | double | val | ) |

virtual inherited

Set maximal distance from center of coordinate system.

Set maximal distance from center of coordinate system at which a Photon may hit the object.

Parameters

  val | new rmax_ in geometrical units.

## rMax() [2/4]

virtual void Gyoto::Astrobj::Generic::rMax | ( | double | val,
|  | std::string const & | unit )

virtual inherited

Set maximal distance from center of coordinate system.

Call Generic::rMax(double val) after converting val from unit to geometrical units.

Parameters

  val | rmax_ expressed in unit "unit";
  unit | string...

## rMax() [3/4]

virtual double Gyoto::Astrobj::Generic::rMax | ( | std::string const & | unit | ) |

virtual inherited

Get rmax_ is specified unit.

Call rMax() and convert result to unit.

Parameters

  unit | string

Returns
  double rmax converted to unit

## rMax() [4/4]

virtual double Gyoto::Astrobj::Star::rMax | ( |  | ) |

virtual inherited

Get maximal distance from center of coordinate system.

Get maximal distance from center of coordinate system at which a Photon may hit the object.

Child classes may use the rmax_ member to cache this value, if its current value is DBL_MAX.

It can also be set using rMax().

Returns
  rmax_ in geometrical units

Reimplemented from Gyoto::Astrobj::Generic.

## rotateJs()

Eigen::Vector4d Gyoto::Astrobj::Generic::rotateJs | ( | double | jInu,
|  | double | jQnu,
|  | double | jUnu,
|  | double | jVnu,
|  | double | sin2Chi,
|  | double | cos2Chi ) const

inherited

Apply the rotation matrix with angle Chi to the emission Stokes vector constructed in the fonction from the individual coefficients

## setCst()

void Gyoto::Worldline::setCst | ( | double const * | cst,
|  | size_t const | ncsts )

inherited

Set Metric-specific constants of motion.

The will (re)allocate Worldline::cst_, copy cst into it, and set Worldline::cst_n_.

This is the same as void Worldline:constantsOfMotion(std::vector<double> const cstv) using a C-style array instead of a vector.

## setInitCoord() [1/3]

virtual void Gyoto::Astrobj::StarTrace::setInitCoord | ( | const double | coord[8],
|  | int | dir = 0 )

virtual

Set Initial coordinate.

Set imin_=imax_=i0_, and x[i0]=coord[].

If dir==1, i0_ is set to 0. If dir==-1, i0_ is set to x_size_-1.

If dir==0 and the Worldine has never been computed (i0_==0, imin_==1 and imax_==0), then dir defaults to 1 for a massive particle and -1 for a massless particle.

If dir==0 and the Worldine has already been computed, i0_ is not changed.

Parameters

  coord | new initial coordinates
  dir | direction of integration. 1 for forward integration, -1 for backards integration, 0 for unknown or both

Reimplemented from Gyoto::Worldline.

## setInitCoord() [2/3]

virtual void Gyoto::Worldline::setInitCoord | ( | const double | coord[8],
|  | int | dir,
|  | double const | Ephi[4],
|  | double const | Etheta[4] )

virtual inherited

Set Initial coordinate.

Set imin_=imax_=i0_, and x[i0]=coord[].

If dir==1, i0_ is set to 0. If dir==-1, i0_ is set to x_size_-1.

If dir==0 and the Worldine has never been computed (i0_==0, imin_==1 and imax_==0), then dir defaults to 1 for a massive particle and -1 for a massless particle.

If dir==0 and the Worldine has already been computed, i0_ is not changed.

Parameters

  coord | new initial coordinates
  dir | direction of integration. 1 for forward integration, -1 for backards integration, 0 for unknown or both
  Ephi | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.
  Etheta | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.

## setInitCoord() [3/3]

virtual void Gyoto::Worldline::setInitCoord | ( | double const | pos[4],
|  | double const | vel[3],
|  | int | dir = 0 )

virtual inherited

Set initial coordinate.

Parameters

  pos | initial 4-position
  vel | initial 3-velocity
  dir | direction of integration

## setInitialCondition() [1/3]

virtual void Gyoto::Astrobj::StarTrace::setInitialCondition | ( | double const | coord[8] | ) |

virtual

Same as Worldline::setInitialCondition(gg, coord, sys,1).

Reimplemented from Gyoto::Astrobj::Star.

## setInitialCondition() [2/3]

void Gyoto::Worldline::setInitialCondition | ( | SmartPointer< Metric::Generic > | gg,
|  | const double | coord[8],
|  | const int | dir )

inherited

Set or re-set the initial condition prior to integration.

Parameters

  gg | Gyoto::SmartPointer to the Gyoto::Metric in this universe;
  coord | 8 element array containing the initial condition, i.e. the 4-position and the 4-velocity of the Photon at the receiving end;
  dir | direction: 1 for future, -1 for past.

## setInitialCondition() [3/3]

void Gyoto::Worldline::setInitialCondition | ( | SmartPointer< Metric::Generic > | gg,
|  | const double | coord[8],
|  | const int | dir,
|  | double const | Ephi[4],
|  | double const | Etheta[4] )

inherited

Set or re-set the initial condition prior to integration.

Parameters

  gg | Gyoto::SmartPointer to the Gyoto::Metric in this universe;
  coord | 8 element array containing the initial condition, i.e. the 4-position and the 4-velocity of the Photon at the receiving end;
  dir | direction: 1 for future, -1 for past.
  Ephi | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.
  Etheta | initial value of base vector to parallel-transport. Ignored if parallel_transport_ is false.

## setParameter() [1/2]

virtual int Gyoto::Astrobj::Star::setParameter | ( | std::string | name,
|  | std::string | content,
|  | std::string | unit )

virtual inherited

Set parameter by name.

This function is used when parsing an XML description, if no Property of this name is found. Overriding implementation should fall-back on calling the direct's parent implementation:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual int setParameter(std::string name,
std::string content,
std::string unit);
};
int B::setParameter(std::string name,
std::string content,
std::string unit) {
if (name=="Duff") doSomething(content, unit);
else return A::setParameter(name, content, unit);
return 0; // name was known
}

Parameters

  name | XML name of the parameter (XML entity). This may have a path component, e.g. "Astrobj::Radius", in which case a property named "Astrobj" will be sought in the current object, and setParameter will be called recusrively on this Astrobj with Radius as name.
  content | string representation of the value
  unit | string representation of the unit

Returns
  0 if this parameter is known, 1 if it is not.

Reimplemented from Gyoto::Object.

## setParameter() [2/2]

virtual void Gyoto::Object::setParameter | ( | Gyoto::Property const & | p,
|  | std::string const & | name,
|  | std::string const & | content,
|  | std::string const & | unit )

virtual inherited

Set parameter by Property (and name).

This function is used when parsing an XML description, if Property (p) of this name is found (i.e. either p.name or p.name_false is equal to name). Implementation should fall-back on calling the direct's parent implementation:

class A: public Object {};
class B: public A {
using B::setParameter;
virtual void setParameter(Gyoto::Property const &p,
std::string name,
std::string content,
std::string unit);
};
void B::setParameter(Gyoto::Property const &p,
std::string name,
std::string content,
std::string unit) {
if (name=="Duff") doSomething(content, unit);
else A::setParameter(p, name, content, unit);
}

Parameters

  p | Property that matches name (p.name == name or p.name_false == name)
  name | XML name of the parameter (XML entity)
  content | string representation of the value
  unit | string representation of the unit

Reimplemented in Gyoto::Astrobj::PolishDoughnut.

## setParameters()

virtual void Gyoto::Astrobj::Star::setParameters | ( | FactoryMessenger * | fmp | ) |

virtual inherited

Main loop in Subcontractor_t function.

The Subcontractor_t function for each Astrobj kind should look somewhat like this (templated as Gyoto::Astrobj::Subcontractor<MyKind>):

SmartPointer<Astrobj::Generic>
Gyoto::Astrobj::MyKind::Subcontractor(FactoryMessenger* fmp) {
SmartPointer<MyKind> ao = new MyKind();
ao -> setParameters(fmp);
return ao;
}
Gyoto::Astrobj::Star::setParameters
virtual void setParameters(FactoryMessenger *fmp)
Main loop in Subcontractor_t function.

Each object kind should implement setParameter(string name, string content, string unit) to interpret the individual XML elements. setParameters() can be overloaded in case the specific Astrobj class needs low level access to the FactoryMessenger. See UniformSphere::setParameters().

Reimplemented from Gyoto::Astrobj::Generic.

## tell()

virtual void Gyoto::Worldline::tell | ( | Gyoto::Hook::Teller * | msg | ) |

protected virtual inherited

This is how a Teller tells.

A teller will basically call listener->tell(this).

Parameters

  msg | Teller* the Teller who is telling... Useful if the Listener listens to several Tellers.

Reimplemented from Gyoto::Hook::Listener.

## transmission()

virtual double Gyoto::Astrobj::Generic::transmission | ( | double | nuem,
|  | double | dsem,
|  | state_t const & | coord_ph,
|  | double const | coord_obj[8] ) const

virtual inherited

Transmission: exp( αν * dsem ).

transmission() computes the transmission of this fluid element or 0 if optically thick. The default implementation returns 1. (no attenuation) if optically thin, 0. if optically thick.

Parameters

  nuem | frequency in the fluid's frame
  coord | Photon coordinate
  dsem | geometrical length in geometrical units

Reimplemented in Gyoto::Astrobj::DynamicalDisk3D, and Gyoto::Astrobj::PatternDisk.

## xAllocate() [1/2]

void Gyoto::Astrobj::StarTrace::xAllocate | ( | size_t | size | ) |

virtual

Allocate x0, x1 etc. with a specified size.

Parameters

  size | : number of cells in each array x0, x1 etc.

Reimplemented from Gyoto::Worldline.

## xAllocate() [2/2]

virtual void Gyoto::Worldline::xAllocate | ( |  | ) |

protected virtual inherited

Allocate x0, x1 etc. with default size.

The default size is GYOTO_DEFAULT_X_SIZE

## xExpand() [1/2]

size_t Gyoto::Astrobj::StarTrace::xExpand | ( | int | dir | ) |

virtual

Expand x0, x1 etc... to hold more elements.

Double the size of arrays x0, x1 etc. and copy old version of the array in the first half if dir =1 and in the second half if dir =-1.

Parameters

  dir | : 1 to expand after last element, -1 to expand before first element

Returns
  ind : if dir=1, new index of old last element, if dir=-1, new index of old first element

Reimplemented from Gyoto::Worldline.

## xExpand() [2/2]

virtual void Gyoto::Worldline::xExpand | ( | double *& | x,
|  | int | dir )

protected virtual inherited

Expand one array to hold more elements.

If you need to expand more arrays than x0_ ... x3_ and the dots, call this on your array before calling xExpand(int dir).

Parameters

  [in,out] | x | array to expand
  [in] | dir |

## xStore()

virtual void Gyoto::Astrobj::StarTrace::xStore | ( | size_t | ind,
|  | state_t const & | coord,
|  | double | tau )

virtual

Store coord at index ind.

Reimplemented from Gyoto::Worldline.

## Member Data Documentation

## __defaultfeatures

int Gyoto::Astrobj::Generic::__defaultfeatures

private inherited

Whether some virtual methods are implemented.

The default implementations of some methods call one-another. This member is used internally to avoid infinite recursion.

## abstol_

double Gyoto::Worldline::abstol_

protected inherited

Absolute tolerance of the integrator.

Used by the adaptive integrators implemented in IntegState::Boost. Refer to the boost::numeric::odeint documentation for more details.

## delta_

double Gyoto::Worldline::delta_

protected inherited

Initial integrating step.

Default: GYOTO_DEFAULT_DELTA

## delta_max_

double Gyoto::Worldline::delta_max_

protected inherited

Maximum integration step for the adaptive integrator.

The default (GYOTO_DEFAULT_DELTA_MAX) is usually fine.

For IntegState::Legacy, set it in the Metric instead!

## delta_max_over_r_

double Gyoto::Worldline::delta_max_over_r_

protected inherited

Numerical tuning parameter.

For IntegState::Legacy, set it in the Metric instead!

Ensure that delta (the numerical integration step) is never larger than a fraction of the distance between the current location and the center of the coordinate system.

The default (GYOTO_DEFAULT_DELTA_MAX_OVER_R) is usually fine.

## delta_min_

double Gyoto::Worldline::delta_min_

protected inherited

Minimum integration step for the adaptive integrator.

The default (GYOTO_DEFAULT_DELTA_MIN) is usually fine.

For IntegState::Legacy, set it in the Metric instead!

## deltamaxinsidermax_

double Gyoto::Astrobj::Generic::deltamaxinsidermax_

protected inherited

Maximum Photon integration step inside rmax_ [geometrical units].

Maximum step for Photon integation when inside the sphere of radius rmax_.

deltamaxinsidermax_ is in geometrical units.

## kind_

std::string Gyoto::Object::kind_

protected inherited

The "kind" that is output in the XML entity.

E.g. for an Astrobj, fillElement() will ensure

<Astrobj kind="kind_" ...>...</Astrobj>

is written.

## maxCrossEqplane_

double Gyoto::Worldline::maxCrossEqplane_

protected inherited

Maximum number of crossings of equatorial plane.

Used to determine how much higher-order image features should be kept.

## mutex_

pthread_mutex_t Gyoto::SmartPointee::mutex_

private inherited

A mutex.

When compiled with libpthread

## parallel_transport_

bool Gyoto::Worldline::parallel_transport_

protected inherited

Whether to parallel transport a local triad.

Typically used to trace the base in which the Stokes parameters are expressed in the context of polarization.

## plugins_

std::vector<std::string> Gyoto::Object::plugins_

protected inherited

The plug-ins that needs to be loaded to access this instance's class.

E.g. for an Astrobj, fillElement() will ensure

<Astrobj ... plugin="plugins_">...</Astrobj>

is written.

## reltol_

double Gyoto::Worldline::reltol_

protected inherited

Absolute tolerance of the integrator.

Used by the adaptive integrators implemented in IntegState::Boost. Refer to the boost::numeric::odeint documentation for more details.

## rmax_

double Gyoto::Astrobj::Generic::rmax_

protected inherited

Maximum distance to the center of the coordinate system [geometrical units].

Maximum distance from the center of the coordinate system at which a photon may hit the object. Child classes may compute a decent value for rmax_ at any time if rmax_ is DBL_MAX. External classes (Photons in particular) must use rMax() to access this information.

rmax_ is in geometrical units.

## secondary_

bool Gyoto::Worldline::secondary_

protected inherited

Experimental: choose 0 to compute only primary image.

This feature is in development.

## x_size_

size_t Gyoto::Worldline::x_size_

protected inherited

Coordinate of Second base vector to parallel transport.

Size of x0_, x1_... arrays

The documentation for this class was generated from the following file:

- GyotoStarTrace.h